.386

LOCALS @@
ASSUME CS:CODE

code segment word private use16

    callf          EQU <call far ptr>
    calln          EQU <call>

    extended_1     EQU <tbyte ptr ss:[bx + 4]>
    extended_2     EQU <tbyte ptr ss:[bx + 14]>
    extended_3     EQU <tbyte ptr ss:[bx + 24]>

    double_1       EQU <qword ptr ss:[bx + 4]>
    double_2       EQU <qword ptr ss:[bx + 12]>
    double_3       EQU <qword ptr ss:[bx + 20]>

    _2             dq 0.50E+0000
    EXTRN          _p180,_180p


public Power       ;  X  ⥯ Y

Power proc
         mov       bx,sp
         fld       double_1    ; fld y
         fld       double_2    ; fld x
         fyl2x
         fld       st
         frndint
         fsub      st(1),st
         fxch
         fmul      qword ptr cs:_2
         f2xm1
         fld1
         faddp
         fmul      st,st
         fscale
         fstp      st(1)
         retf      16
Power endp


public Exp

Exp proc
         mov       bx,sp
         fld       double_1         ; fld x
         fldl2e
         fmulp
         fld       st
         frndint
         fsub      st(1),st
         fxch
         fmul      qword ptr cs:_2
         f2xm1
         fld1
         faddp
         fmul      st,st
         fscale
         fstp      st(1)
         retf      8
Exp endp


public Sgn         ;  ᫠. 筮   BASIC

Sgn proc
         mov       bx,sp
         fldz
         fld       extended_1
         fcompp
         fstsw     ax
         sahf
         je        @@Zero
         jb        @@Negative
         mov       al,1
         retf      10
    @@Zero:
         xor       al,al
         retf      10
    @@Negative:
         mov       al,-1
         retf      10
Sgn endp


public AlikeFloat  ; ᫠ X  Y  ࠧ  D

AlikeFloat proc
         mov       bx,sp
         fld       extended_3    ; x
         fld       extended_2    ; y
         fsubp                          ; st = x - y
         fld       st                   ; st = st(1) = x - y
         fabs
         fld       extended_1    ; d
         fabs                           ; st = |d| ; st(1) = |x - y|
         fcompp
         fstsw     ax
         sahf
         jb        @@NotAlike
         xor       al,al
         fstp      st
         retf      30
    @@NotAlike:
         fldz
         fcompp
         fstsw     ax
         sahf
         ja        @@Y_above
         mov       al,1
         retf      30
    @@Y_above:
         mov       al,-1
         retf      30
AlikeFloat endp


public SinH        ; ࡮᪨ ᨭ

SinH proc
         pop       eax
         callf     Exp
         fld       st
         fld1
         fdivrp
         push      eax
         fsubp
         fmul      qword ptr cs:_2
         retf
SinH endp


public CosH        ; ࡮᪨ ᨭ

CosH proc
         pop       eax
         callf     Exp
         fld       st
         fld1
         fdivrp
         push      eax
         faddp
         fmul      qword ptr cs:_2
         retf
CosH endp


public TanH

TanH proc
         pop       eax
         callf     Exp
         fld       st
         fld1
         push      eax
         fdivrp             ; st = e^(-x); st(1) = e^(x)
         fld       st(1)
         fsub      st,st(1)
         fxch      st(2)
         faddp
         fdivp
         retf
TanH endp


public  ASinH

ASinH proc
         mov       bx,sp
         fld       double_1
         fld       st
         fmul      st,st
         fld1
         faddp
         fsqrt
         faddp
         fldln2
         fxch
         fyl2x
         retf      8
ASinH endp


public  ACosH

ACosH proc
         mov       bx,sp
         fld       double_1
         fld       st
         fmul      st,st
         fld1
         fsubp
         fsqrt
         faddp
         fldln2
         fxch
         fyl2x
         retf      8
ACosH endp


public  ATanH

ATanH proc
         mov       bx,sp
         fld       double_1
         fld       st
         fld1
         fcom      st(1)
         fstsw     ax
         sahf
         jb        @@TooBig
         fadd      st(2),st
         fsubrp
         fdivp
         fldln2
         fxch
         fyl2x
         fmul      qword ptr cs:_2
         retf      8
    @@TooBig:
         fcompp
         ffree     st
         retf      8
ATanH endp

code ends

end
