{ !!!      }
{                 386DX+387 !! }

unit Math;

interface

const
     _p180  : extended = 3.14159265358979323846264 / 180;
     _180p  : extended = 180 / 3.14159265358979323846264;

function Pi : extended; inline(
   $D9/$EB                   { fldpi                       }
);

function E : extended; inline(
   $D9/$E8/                  { fld1                        }
   $D9/$EA/                  { fldl2e                      }
   $D8/$E1/                  { fsub    st,st(1)            }
   $D9/$F0/                  { f2xm1                       }
   $D9/$C9/                  { fxch                        }
   $DC/$C1/                  { fadd st(1),st               }
   $D8/$C0/                  { fadd st,st                  }
   $DE/$C9                   { fmulp                       }
);

function Tan(a : double) : double; inline(
   $8B/$DC/                  { mov     bx,sp               }
   $36/$DD/$07/              { fld     qword ptr ss:[bx]   }
   $D9/$F2/                  { fptan                       }
   $83/$C4/$08/              { add     sp,8                }
   $DD/$D8                   { fstp    st                  }
);

{ 筮 ⠭ Tan(a),  稭  ࠤ }
function GTan(a : double) : double; inline(
   $8B/$DC/                  { mov     bx,sp               }
   $DB/$2E/_p180/            { fld     tbyte ptr [_p180]   }
   $36/$DC/$0F/              { fmul    qword ptr ss:[bx]   }
   $D9/$F2/                  { fptan                       }
   $83/$C4/$08/              { add     sp,8                }
   $DD/$D8                   { fstp    st                  }
);

function ArcTan(a : double) : double; inline(
   $8B/$DC/                  { mov     bx,sp               }
   $36/$DD/$07/              { fld     qword ptr ss:[bx]   }
   $D9/$E8/                  { fld1                        }
   $83/$C4/$08/              { add     sp,8                }
   $D9/$F3                   { fpatan                      }
);

function GArcTan(a : double) : double; inline(
   $8B/$DC/                  { mov     bx,sp               }
   $36/$DD/$07/              { fld     qword ptr ss:[bx]   }
   $D9/$E8/                  { fld1                        }
   $83/$C4/$08/              { add     sp,8                }
   $D9/$F3/                  { fpatan                      }
   $DB/$2E/_180p/            { fld     tbyte ptr [_180p]   }
   $DC/$C9/                  { fmul    qword ptr ss:[bx]   }
   $DD/$C0/
   $D9/$F7
);

function Sin(a : double) : double; inline(
   $8B/$DC/                  { mov     bx,sp               }
   $36/$DD/$07/              { fld     qword ptr ss:[bx]   }
   $D9/$FE/                  { fsin                        }
   $83/$C4/$08               { add     sp,8                }
);

function GSin(a : double) : double; inline(
   $8B/$DC/                  { mov     bx,sp               }
   $DB/$2E/_p180/            { fld     tbyte ptr [_p180]   }
   $36/$DC/$0F/              { fmul    qword ptr ss:[bx]   }
   $D9/$FE/                  { fsin                        }
   $83/$C4/$08               { add     sp,8                }
);

function Cos(a : double) : double; inline(
   $8B/$DC/                  { mov     bx,sp               }
   $36/$DD/$07/              { fld     qword ptr ss:[bx]   }
   $D9/$FF/                  { fcos                        }
   $83/$C4/$08               { add     sp,8                }
);

function GCos(a : double) : double; inline(
   $8B/$DC/                  { mov     bx,sp               }
   $DB/$2E/_p180/            { fld     tbyte ptr [_p180]   }
   $36/$DC/$0F/              { fmul    qword ptr ss:[bx]   }
   $D9/$FF/                  { fcos                        }
   $83/$C4/$08               { add     sp,8                }
);

function Ln(a : double) : double; inline(
   $8B/$DC/                  { mov     bx,sp               }
   $D9/$ED/                  { fldln2                      }
   $36/$DD/$07/              { fld     qword ptr ss:[bx]   }
   $D9/$F1/                  { fyl2x                       }
   $83/$C4/$08               { add     sp,8                }
);

function Log(a : double) : double; inline(
   $8B/$DC/                  { mov     bx,sp               }
   $D9/$EC/                  { fldlg2                      }
   $36/$DD/$07/              { fld     qword ptr ss:[bx]   }
   $D9/$F1/                  { fyl2x                       }
   $83/$C4/$08               { add     sp,8                }
);

{  ᫠ Y  ᭮ X  }
function LogX(y,x : double) : double; inline(
   $8B/$DC/                  { mov     bx,sp               }
   $D9/$E8/                  { fld1                        }
   $D9/$E8/                  { fld1                        }
   $36/$DD/$47/$08/          { fld     qword ptr ss:[bx+8] }
   $D9/$F1/                  { fyl2x                       }
   $DE/$F9/                  { fdivp                       }
   $36/$DD/$07/              { fld     qword ptr ss:[bx]   }
   $D9/$F1/                  { fyl2x                       }
   $83/$C4/$10               { add     sp,16               }
);

{ ⠥ ४⭮  X <= 0.8 }
function SmallExp(x : double) : double; inline(
   $8B/$DC/                  { mov     bx,sp               }
   $D9/$E8/                  { fld1                        }
   $36/$DD/$07/              { fld     qword ptr ss:[bx]   }
   $D9/$EA/                  { fldl2e                      }
   $83/$C4/$08/              { add     sp,8                }
   $DE/$C9/                  { fmulp                       }
   $D9/$F0/                  { f2xm1                       }
   $DE/$C1                   { faddp                       }
);

{ ᫨  BitNum ⠭, 頥 TRUE }
function Bit(x : longint; BitNum : word) : wordbool; inline(
   $59/                      { pop     cx                  }
   $66/$5B/                  { pop     ebx                 }
   $66/$33/$C0/              { xor     eax,eax             }
   $FE/$C0/                  { inc     al                  }
   $66/$D3/$E0/              { shl     eax,cl              }
   $66/$23/$C3/              { and     eax,ebx             }
   $66/$D3/$E8               { shr     eax,cl              }
);

function Power(x,y : double) : double;
function Exp(x : double) : double;

function Sgn(x : extended) : shortint;
function AlikeFloat(x,y,d : extended) : shortint;

function SinH(x : double) : double;
function ASinH(x : double) : double;
function CosH(x : double) : double;
function ACosH(x : double) : double;
function TanH(x : double) : double;
function ATanH(x : double) : double;

implementation

function Power; external;
function Exp; external;

function Sgn; external;
function AlikeFloat; external;

function SinH; external;
function ASinH; external;
function CosH; external;
function ACosH; external;
function TanH; external;
function ATanH; external;

{$L MATH.OBJ}

end.
